x = new Object;

// "Get URL parameter" helper function
function gup( name )
{
  var regexS = "[\\?&]"+name+"=([^&#]*)";
  var regex = new RegExp( regexS );
  var tmpURL = window.location.href;
  var results = regex.exec( tmpURL );
  if( results == null )
    return "";
  else
    return results[1];
}

x.map = gup("map");
x.program = gup("program");

legend_content = "";

// append to legend content, performing an expansion on all found variables
function ap(txt) {
    for (prop in x) {
        var re = new RegExp("\\[" + prop + "\\]", "g");
        txt = txt.replace(re, x[prop]);
    }
    legend_content += txt;
}

function isLayerSelected(l) {
  var regexS = "[\\?&]layer.?=" + l ;
  var regex = new RegExp( regexS );
  var tmpURL = window.location.href;
  var results = regex.exec( tmpURL );
  return ( results != null );
};

// javascript for group section of the legend
function jsl_g(aa) {
    ap('<tr><td colspan="3">');
    if (aa.ogt) {
        ap("<strong>[ogt]</strong>");
        ap('&nbsp;<font size="-1"><a target="_blank" class="homelink" title="Web Map Service (WMS) - [ogt] group" href="[program]?map=[map]&version=1.1.1&service=WMS&request=GetMap&layers=[ogt]&SRS=EPSG:4283&bbox=111,-48.3,158,-4.2&transparent=true">WMS</a>  </font>');
    } else {
        ap("<strong>[lgn]</strong>");
        ap('&nbsp;<font size="-1"><a target="_blank" class="homelink" title="Web Map Service (WMS) - [lgn] group" href="[program]?map=[map]&version=1.1.1&service=WMS&request=GetMap&layers=[lgn]&SRS=EPSG:4283&bbox=111,-48.3,158,-4.2&transparent=true">WMS</a>  </font>');
        
    }
    ap("</td></tr>");
};

// javascript for layer section of the legend
function jsl_l(aa) {
    ap('<tr><td><input type="checkbox" name="layer" value=[lln]');
    if (isLayerSelected(aa.lln)) ap(' CHECKED');
    ap('>');
    if (aa.lt == 4) ap("<img src=[li] width=20 height=19>");
    var wfsmap = aa.map;
    
    // Use different WFS files for certain groups
    if (aa.ogt == "Radar Data") wfsmap = aa["map"].replace(/[^\/]+\.map/, "radar.map");
    if (aa.ogt == "TIFS Data") wfsmap = aa["map"].replace(/[^\/]+\.map/, "tifs.map");

    ap('</td><td colspan=2><font size="-1"><a target="_blank" class="homelink" title="Web Feature Service (WFS) to [ot] (where applicable)" href="[program]?map=' + wfsmap + '&version=1.0.0&service=WFS&request=GetFeature&typename=[lln]"> [ot]</a>&nbsp; <a target="_blank" class="homelink" title="Web Map Service (WMS) - [ot] data" href="[program]?map=[map]&version=1.1.1&service=WMS&request=GetMap&layers=[lln]&SRS=EPSG:4283&bbox=111,-48.3,158,-4.2&transparent=true">WMS</a></font>');

    ap("</td></tr>");
};

// javascript for class section of the legend
function jsl_c(aa) {
    ap('<tr><td></td><td><img src="[li]" width=20 height=19></td>');
    ap('<td><font size="-1">[lcn]</font>');
    ap("</td></tr>");
};

function insertLegend() {
    e = document.getElementById("legendParent");
    e.innerHTML = legend_content;
}


